#include  <STC15F2K60S2.H>
#include  "api.h"
#include  "nrf24l01.h"
#include  "uart.h"
#include  "delay.h"

sbit KEY1 = P2^3;
sbit KEY2 = P2^4;
sbit KEY3 = P2^5;
sbit KEY4 = P2^6;
sbit LED  = P5^5;
unsigned char TX_BUF[TX_PLOAD_WIDTH];

void GPIO_Init(void)
{
	P1M0 = 0; 		 P1M1 = 0;
	P2M0 = 0; 		 P2M1 = 0;
	P3M0 = 0; 		 P3M1 = 0;
	P4M0 = 0; 		 P4M1 = 0;
	P5M0 = 0; 		 P5M1 = 0;
}



void KeyScan(void)
{
	
	if(!KEY1)                              //⵽͵ƽ˵
	{
		delay_ms(10);                       //ʱȥһ10-20ms
		if(!KEY1)                         //ٴȷϰǷ£ûа˳
		{
			LED = 0;
			while(!KEY1);                 //ȷϰ°ȴͷţû˳
			{
				TX_BUF[0] = 1;            //ת
				TX_BUF[1] = 0;
				TX_BUF[2] = 0;
				TX_BUF[3] = 1;
				TX_BUF[4] = 0x11;
				TX_BUF[5] = 0x11;
				TX_Mode(TX_BUF);  //
				delay_ms(50);
		//		SPI_RW_Reg(WRITE_REG+STATUS,0xff); // TX_DSMAX_RTжϱ־
					while(Check_ACK());      //Ƿ
		//		SPI_RW(FLUSH_TX);//FIFO
				SendString("ת\n");				
				SendString("Waiting for commend:......\n");			
				LED = 1;
			//	SPI_RW_Reg(WRITE_REG+STATUS,0xff); //״̬Ĵ
			}
		}
	}

	else if(!KEY2)                                //⵽͵ƽ˵
	{
		delay_ms(10);                              //ʱȥһ10-20ms
		if(!KEY2)                                //ٴȷϰǷ£ûа˳
		{
			LED = 0;
			while(!KEY2);                        //ȷϰ°ȴͷţû˳
			{
				TX_BUF[0] = 0;                   //ת
				TX_BUF[1] = 1;
				TX_BUF[2] = 1;
				TX_BUF[3] = 0;
				TX_BUF[4] = 0x22;
				TX_BUF[5] = 0x22;
				TX_Mode(TX_BUF);        //
				delay_ms(50);
			//	SPI_RW_Reg(WRITE_REG+STATUS,0xff); // TX_DSMAX_RTжϱ־
				while(Check_ACK());      //Ƿ
			//	SPI_RW(FLUSH_TX);//FIFO
				SendString("ת\n");
				SendString("Waiting for commend:......\n");
				LED = 1;
			//	SPI_RW_Reg(WRITE_REG+STATUS,0xff); //״̬Ĵ
			}
		}
	}
	
	else if(!KEY3)                             //⵽͵ƽ˵
	{  
		delay_ms(10);                           //ʱȥһ10-20ms
		if(!KEY3)                             //ٴȷϰǷ£ûа˳
		{
			LED = 0;
			while(!KEY3);                     //ȷϰ°ȴͷţû˳
			{
				TX_BUF[0] = 1;                //ǰ
				TX_BUF[1] = 0;
				TX_BUF[2] = 1;
				TX_BUF[3] = 0;
				TX_BUF[4] = 0x33;
				TX_BUF[5] = 0x33;
				TX_Mode(TX_BUF);     //
				delay_ms(50);
			//	SPI_RW_Reg(WRITE_REG+STATUS,0xff); // TX_DSMAX_RTжϱ־
					while(Check_ACK());      //Ƿ
			//	SPI_RW(FLUSH_TX);//FIFO
				SendString("ǰ\n");
				SendString("Waiting for commend:......\n");
				LED = 1;
		//		SPI_RW_Reg(WRITE_REG+STATUS,0xff); //״̬Ĵ
			}
		}
	}

	else if(!KEY4)                            //⵽͵ƽ˵
	{
		delay_ms(10);                           //ʱȥһ10-20ms
		if(!KEY4)                             //ٴȷϰǷ£ûа˳
		{
			LED = 0;
			while(!KEY4);                      //ȷϰ°ȴͷţû˳
			{
				TX_BUF[0] = 0;						      //
				TX_BUF[1] = 1;
				TX_BUF[2] = 0;
				TX_BUF[3] = 1;
				TX_BUF[4] = 0x44;
				TX_BUF[5] = 0x44;
				TX_Mode(TX_BUF);        //
				delay_ms(50);
				//SPI_RW_Reg(WRITE_REG+STATUS,0xff); // TX_DSMAX_RTжϱ־
				while(Check_ACK());      //Ƿ
			//	SPI_RW(FLUSH_TX);//FIFO
				SendString("\n");
				SendString("Waiting for commend:......\n");
				LED = 1;
			//	SPI_RW_Reg(WRITE_REG+STATUS,0xff); //״̬Ĵ
			}

		}
	}
	else
	{
		    TX_BUF[0] = 1;						      //ɲ
				TX_BUF[1] = 1;
				TX_BUF[2] = 1;
				TX_BUF[3] = 1;
				TX_BUF[4] = 0x55;
				TX_BUF[5] = 0x55;
				TX_Mode(TX_BUF);        //
				delay_ms(50);
				while(Check_ACK());      //Ƿ
	}

}


  
void main (void)
{
	GPIO_Init();
	UartInit();
	delay_ms(200);
	SendString("Waiting for commend:......\n");
	while(1)
	{
		LED =1;
		SPI_RW_Reg(WRITE_REG+STATUS,0xff); 
		KeyScan();
	}
}

