


#include <reg51.h>
#include <api.h>

#define uchar unsigned char
#define uint  unsigned int

/***************************************************/
#define TX_ADR_WIDTH   5  // 5ֽڿȵķ/յַ
#define TX_PLOAD_WIDTH 6  // ͨЧݿ

sbit CE   = P2^5;
sbit CSN  = P2^4;
sbit SCK  = P2^3;
sbit MOSI = P2^2;
sbit MISO = P2^1;
sbit IRQ  = P2^0;
//sbit KEY  = P3^4;

//Aƶ˿	
//sbit ENA = P1^0;
sbit IN1 = P1^1;
sbit IN2 = P1^2;

//Bƶ˿	ұ
sbit IN3 = P1^3;
sbit IN4 = P1^4;
//sbit ENB = P1^5;

uchar code TX_ADDRESS[TX_ADR_WIDTH] = {0x34,0x43,0x10,0x10,0x01};  // һ̬͵ַ
volatile uchar RX_BUF[TX_PLOAD_WIDTH];
uchar TX_BUF[TX_PLOAD_WIDTH];
uchar flag;
//uchar DATA = 0x01;
uchar bdata sta;
sbit  RX_DR	 = sta^6;
sbit  TX_DS	 = sta^5;
sbit  MAX_RT = sta^4;
/**************************************************/

/**************************************************
: init_io()

:
    ʼIO
/**************************************************/
void init_io(void)
{
	CE  = 0;        // 
	CSN = 1;        // SPIֹ
	SCK = 0;        // SPIʱõ
	IRQ = 1;        // жϸλ
}
/**************************************************/






/**************************************************
SPI_RW()


    SPIЭ飬дһֽݵnRF24L01ͬʱnRF24L01
	һֽ
/**************************************************/
uchar SPI_RW(uchar byte)
{
	uchar i;
   	for(i=0; i<8; i++)          // ѭ8
   	{
   		MOSI = (byte & 0x80);   // byteλMOSI
   		byte <<= 1;             // һλλλ
   		SCK = 1;                // SCKnRF24L01MOSI1λݣͬʱMISO1λ
   		byte |= MISO;       	// MISObyteλ
   		SCK = 0;            	// SCKõ
   	}
    return(byte);           	// ضһֽ
}
/**************************************************/

/**************************************************
SPI_RW_Reg()


    дvalueregĴ
/**************************************************/
uchar SPI_RW_Reg(uchar reg, uchar value)
{
	uchar status;
  	CSN = 0;                   // CSNõͣʼ
  	status = SPI_RW(reg);      // ѡĴͬʱ״̬
  	SPI_RW(value);             // ȻдݵüĴ
  	CSN = 1;                   // CSNߣݴ
  	return(status);            // ״̬Ĵ
}
/**************************************************/

/**************************************************
SPI_Read()


    regĴһֽ
/**************************************************/
uchar SPI_Read(uchar reg)
{
	uchar reg_val;
  	CSN = 0;                    // CSNõͣʼ
  	SPI_RW(reg);                // ѡĴ
  	reg_val = SPI_RW(0);        // ȻӸüĴ
  	CSN = 1;                    // CSNߣݴ
  	return(reg_val);            // ؼĴ
}


/**************************************************
SPI_Read_Buf()


    regĴbytesֽڣͨȡͨ
	ݻ/͵ַ
/**************************************************/
uchar SPI_Read_Buf(uchar reg, uchar * pBuf, uchar bytes)
{
	uchar status, i;
  	CSN = 0;                    // CSNõͣʼ
  	status = SPI_RW(reg);       // ѡĴͬʱ״̬
  	for(i=0; i<bytes; i++)
    	pBuf[i] = SPI_RW(0);    // ֽڴnRF24L01
  	CSN = 1;                    // CSNߣݴ
  	return(status);             // ״̬Ĵ
}

/**************************************************
SPI_Write_Buf()


    pBufед뵽nRF24L01ͨд뷢
	ͨݻ/͵ַ
/**************************************************/
uchar SPI_Write_Buf(uchar reg, uchar * pBuf, uchar bytes)
{
	uchar status, i;
  	CSN = 0;                    // CSNõͣʼ
  	status = SPI_RW(reg);       // ѡĴͬʱ״̬
  	for(i=0; i<bytes; i++)
    	SPI_RW(pBuf[i]);        // ֽдnRF24L01
  	CSN = 1;                    // CSNߣݴ
  	return(status);             // ״̬Ĵ
}

/**************************************************
RX_Mode()


    nRF24L01Ϊģʽȴշ豸ݰ
/**************************************************/
void RX_Mode(void)
{
	CE = 0;
  	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  // 豸ͨ0ʹúͷ豸ͬķ͵ַ
  	SPI_RW_Reg(WRITE_REG + EN_AA, 0x00);               // ʹܽͨ0ԶӦ
  	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);           // ʹܽͨ0
  	SPI_RW_Reg(WRITE_REG + RF_CH, 30);                 // ѡƵͨ0x40
  	SPI_RW_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  // ͨ0ѡͷͨͬЧݿ
  	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);            // ݴ1Mbps书0dBmŴ
  	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);              // CRCʹܣ16λCRCУ飬ϵ磬ģʽ
  CE = 1;                                            // CE豸
}
/**************************************************/

/**************************************************
TX_Mode()


    nRF24L01ΪģʽCE=110us
	130us䣬ݷͽ󣬷ģԶת
	ģʽȴӦźš
/**************************************************/
//void TX_Mode(uchar * BUF)
//{
//	CE = 0;
//  	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);     // д뷢͵ַ
//  	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  // ΪӦ豸ͨ0ַͷ͵ַͬ
//  	SPI_Write_Buf(WR_TX_PLOAD, BUF, TX_PLOAD_WIDTH);                  // дݰTX FIFO
//  	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);       // ʹܽͨ0ԶӦ
//  	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);   // ʹܽͨ0
//  	SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x0a);  // Զطʱȴ250us+86usԶط10
//  	SPI_RW_Reg(WRITE_REG + RF_CH, 40);         // ѡƵͨ0x40
//  	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);    // ݴ1Mbps书0dBmŴ
//  	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);      // CRCʹܣ16λCRCУ飬ϵ
//	CE = 1;
//}
/**************************************************/

/**************************************************
Check_ACK()


    豸޽յݰ趨ûյӦ
	Ƿط
/**************************************************/
//uchar Check_ACK(bit clear)
//{
//	while(IRQ);
//	sta = SPI_RW(NOP);                    // ״̬Ĵ
//	if(MAX_RT)
//		if(clear)                         // ǷTX FIFOûڸλMAX_RTжϱ־ط
//			SPI_RW(FLUSH_TX);
//	SPI_RW_Reg(WRITE_REG + STATUS, sta);  // TX_DSMAX_RTжϱ־
//	IRQ = 1;
//	if(TX_DS)
//		return(0x00);
//	else
//		return(0xff);
//}
/**************************************************/


//void Set_motor(uchar num,uchar mode)
//{
//	if(num==1)                                     //ߵ
//	{
//		if(mode==1)
//			{IN1=0;IN2=1;ENA=1;}//ת
//		else if(mode==2)
//		    {IN1=1;IN2=0;ENA=1;}//ת
//		else
//			{IN1=1;IN2=1;ENA=1;}//ɲ
//	}
//	else if(num==2)                              //ұߵ
//	{
//		if(mode==1)
//			{IN3=0;IN4=1;ENB=1;}//ת
//		else if(mode==2)
//		    {IN3=1;IN4=0;ENB=1;}//ת
//		else
//			{IN3=1;IN4=1;ENB=1;}//ɲ
//	}
//}


/**************************************************
main()


    
/**************************************************/
void main(void)
{
	init_io();		              // ʼIO
	RX_Mode();		              // Ϊģʽ
	P0 = 0xff;
	while(1)
	{
	
//		LED = 0;
		sta = SPI_Read(STATUS);	  // ״̬Ĵ
	    if(RX_DR)				  // жǷܵ
		{
			SPI_Read_Buf(RD_RX_PLOAD, RX_BUF, TX_PLOAD_WIDTH);  // RX FIFO
			flag = 1;
		}
		SPI_RW_Reg(WRITE_REG + STATUS, sta);  // RX_DSжϱ־
		//delay_ms();  
		if(flag)		           // 
		{			
			flag = 0;		       // ־			
			
			if(RX_BUF[4] == 0x11 && RX_BUF[5] == 0x11)      //ǰ
			{
				IN1 = 0;    IN2 = 1;                            
				IN3 = 0;    IN4 = 1;
				
			}
			else if(RX_BUF[4] == 0x22 && RX_BUF[5] == 0x22)      //
			{
				IN1 = 1;    IN2 = 0;                            
				IN3 = 1;    IN4 = 0;
				
			}
			else if(RX_BUF[4] == 0x33 && RX_BUF[5] == 0x33)      //ת
			{
				IN1 = 1;    IN2 = 0;                            
				IN3 = 0;    IN4 = 1;
				
			}
			else if(RX_BUF[4] == 0x44 && RX_BUF[5] == 0x44)      //ת
			{
				IN1 = 0;    IN2 = 1;                            
				IN3 = 1;    IN4 = 0;
				
			}
			else if(RX_BUF[4] == 0x55 && RX_BUF[5] == 0x55)      //ɲ
			{
				IN1 = 1;    IN2 = 1;                            
				IN3 = 1;    IN4 = 1;
		  }
		}
	}
}