


#ifndef  __NRF24L01_H__
#define  __NRF24L01_H__

#include <STC15F2K60S2.H>
#include "api.h"

#define TX_ADR_WIDTH    5   // 5 bytes TX(RX) address width
#define TX_PLOAD_WIDTH  6  // 20 bytes TX payload

sbit CE   = P1^2;
sbit CSN  = P1^5;
sbit SCK  = P1^1;
sbit MOSI = P1^4;
sbit MISO = P1^0;
sbit IRQ  = P1^3;


extern unsigned char SPI_RW(unsigned char dat);                           //дһֽڲ˵ַ״̬
extern unsigned char SPI_RW_Reg(unsigned char reg,unsigned char value);  //дһֽڵĴ
extern unsigned char SPI_Read(unsigned char reg);                       //һֽ
extern unsigned char SPI_Write_Buf(unsigned char reg,unsigned char *pBuf,unsigned char uchars);//дֽڲ˵ַ״̬
extern void TX_Mode(unsigned char * BUF);                                          //÷ģʽ
extern unsigned char Check_ACK(void);


#endif